/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections;using UnityEngine.Video;using UnityEngine.UI;using System.Linq;using System;using System.Collections.Generic;using MVR.FileManagementSecure;namespace PluginIdea.SlideControl{public class VideoPlayerModule : SlideModuleBase{public Action<Texture> onVideoTextureSettedCallback;private JSONStorableBool isLoop;private JSONStorableFloat audioVolume;private JSONStorableFloat audioMinDistance;private JSONStorableFloat audioMaxDistance;private JSONStorableFloat playProgress;private JSONStorableUrl videoUrl;private JSONStorableBool isPlay;private JSONStorableBool isUpdateAudioResponse;private JSONStorableFloat playTime;private VideoPlayer videoPlayer;private AudioSource audioSource;private float[] smaples = new float[128];private List<string> videoUrls = new List<string>();private int currentVideoIndex;public VideoPlayerModule(SlideControl ower){Debug.Log(ower.acs);this.ower = ower;}public override void Init(){Utils.CreateSpacer(ower, 20, true);Utils.CreateInfoTextNoScroll(this.ower, Location.GetStr(Location.VideoPlaySubtitle), 35, true);videoUrl = Utils.SetupVideoChooser(ower, Location.GetStr(Location.ChooseVideoFile), $"Custom/Assets/", true, LoadVideoClip, ower.acs);playProgress = Utils.CreateSliderFloat(ower, Location.GetStr(Location.PlayProgress), 0f, 0f, 1f, true, ower.acs);playProgress.setCallbackFunction = SetProgress;playTime = Utils.CreateSliderFloat(ower, Location.GetStr(Location.PlayTime), 0f, 0, 5, true, ower.acs);playTime.setCallbackFunction = SetTime;Utils.CreateButton(ower, Location.GetStr(Location.PlayStop), OnPlayStopClick, true, ower.acs);Utils.CreateButton(ower, Location.GetStr(Location.PlayNext), PlayNext, true, ower.acs);Utils.CreateButton(ower, Location.GetStr(Location.PlayPrev), PlayPrev, true, ower.acs);isLoop = Utils.CreateToggle(ower, Location.GetStr(Location.IsLoop), true, true, ower.acs);isLoop.setCallbackFunction = (val =>{videoPlayer.isLooping = val;});audioVolume = Utils.CreateSliderFloat(ower, Location.GetStr(Location.AudioVolume), 1f, 0f, 1f, true, ower.acs);audioVolume.setCallbackFunction = (val) =>{audioSource.volume = val;};isUpdateAudioResponse = Utils.CreateToggle(ower, Location.GetStr(Location.IsUpdateAudioResponse), false, true, ower.acs);audioMinDistance = Utils.CreateSliderFloat(ower, Location.GetStr(Location.AudioMinDistance), 1f, 0f, 1000f, true, ower.acs);audioMinDistance.setCallbackFunction = (val) =>{audioSource.minDistance = val;};audioMaxDistance = Utils.CreateSliderFloat(ower, Location.GetStr(Location.AudioMaxDistance), 500f, 0f, 1000f, true, ower.acs);audioMaxDistance.setCallbackFunction = (val) =>{audioSource.maxDistance = val;};isPlay = new JSONStorableBool("Is Play", true);ower.RegisterBool(isPlay);AddVideoComponents();}private void SetVideoFiles(string url){string dir = FileManagerSecure.GetDirectoryName(url);List<string> files = new List<string>();Utils.GetAllSubFiles(dir, ref files);if (files.Count > 0){videoUrls = files.Where(u => u.EndsWith(".mp4")).ToList();}}public override void DelayInit(){if (!string.IsNullOrEmpty(videoUrl.val)){videoUrl.Reload();}}public void Reset(){if (videoPlayer != null){videoPlayer.Stop();}videoUrl.val = string.Empty;}public void AddVideoComponents(){videoPlayer = Utils.GetSafeComponent<VideoPlayer>(ower.gameObject);audioSource = Utils.GetSafeComponent<AudioSource>(ower.gameObject);videoPlayer.playOnAwake = false;audioSource.playOnAwake = false;videoPlayer.source = VideoSource.Url;videoPlayer.renderMode = VideoRenderMode.APIOnly;videoPlayer.audioOutputMode = VideoAudioOutputMode.AudioSource;videoPlayer.controlledAudioTrackCount = 1;videoPlayer.EnableAudioTrack(0, true);videoPlayer.SetTargetAudioSource(0, audioSource);videoPlayer.isLooping = isLoop.val;videoPlayer.prepareCompleted += OnVideoPlayerPrepared;audioSource.volume = audioVolume.val;audioSource.minDistance = audioMinDistance.val;audioSource.maxDistance = audioMaxDistance.val;}private void LoadVideoClip(string path){if (string.IsNullOrEmpty(path)) return;SetVideoFiles(path);if (videoUrls.Count > 0){if (ower.IsOnImagePlayType) return;if (!ower.IsInitied) return;if (!isPlay.val) return;currentVideoIndex = 0;VideoDataPrepare();PlayVideo();}}public void PlayNext(){if (videoUrls.Count > 0){currentVideoIndex++;if (currentVideoIndex > videoUrls.Count - 1)                    currentVideoIndex = 0;VideoDataPrepare();PlayVideo();}}public void PlayPrev(){if (videoUrls.Count > 0){currentVideoIndex--;if (currentVideoIndex < 0)                    currentVideoIndex = videoUrls.Count - 1;VideoDataPrepare();PlayVideo();}}private void PlayVideo(){if (!ower.IsOnVideoFramesType){videoPlayer.Play();}}private void VideoDataPrepare(){videoPlayer.Stop();string firstUrl = videoUrls[currentVideoIndex];if (!firstUrl.StartsWith("http:")){string realpath = Utils.GetGameRootDir() + "/" + firstUrl;videoPlayer.url = realpath;videoPlayer.Play();videoPlayer.Pause();}}private void OnVideoPlayerPrepared(VideoPlayer source){Debug.Log(source.url + " is prepared");source.texture.wrapMode = TextureWrapMode.Repeat;source.texture.filterMode = FilterMode.Trilinear;playTime.max = videoPlayer.frameCount / videoPlayer.frameRate;if (onVideoTextureSettedCallback != null) onVideoTextureSettedCallback(source.texture);}private void SetProgress(float progress){if (videoPlayer != null && videoPlayer.isPrepared){long targetFrame = (long)(videoPlayer.frameCount * progress);videoPlayer.frame = targetFrame;}}private void SetTime(float time){if (videoPlayer != null && videoPlayer.isPrepared){long targetFrame = (long)(videoPlayer.frameRate * time);targetFrame = (long)Mathf.Clamp(targetFrame, 0, videoPlayer.frameCount);videoPlayer.frame = targetFrame;}}public void OnUpdate(){}public void Play(){if (videoPlayer != null) videoPlayer.Play();}public void Stop(){if (videoPlayer != null) videoPlayer.Stop();}private void OnPlayStopClick(){if (isPlay.val){isPlay.val = false;videoPlayer.Stop();}else{isPlay.val = true;videoPlayer.Play();}}public override void UnInit(){videoUrl.val = string.Empty;GameObject.Destroy(videoPlayer);GameObject.Destroy(audioSource);}}}